[0%]:   https://upload.wikimedia.org/wikipedia/commons/thumb/5/5c/Progress_00.svg/80px-Progress_00.svg.png "00%"
[10%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/c/c4/Progress_10.svg/80px-Progress_10.svg.png "10%"
[20%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/9/96/Progress_20.svg/80px-Progress_20.svg.png "20%"
[30%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/2/22/Progress_30.svg/80px-Progress_30.svg.png "30%"
[40%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/5c/Progress_40.svg/80px-Progress_40.svg.png "40%"
[50%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/f/f2/Progress_50.svg/80px-Progress_50.svg.png "50%"
[60%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Progress_60.svg/80px-Progress_60.svg.png "60%"
[70%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/5e/Progress_70.svg/80px-Progress_70.svg.png "70%"
[80%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/5/57/Progress_80.svg/80px-Progress_80.svg.png "80%"
[90%]:  https://upload.wikimedia.org/wikipedia/commons/thumb/b/ba/Progress_90.svg/80px-Progress_90.svg.png "90%"
[100%]: https://upload.wikimedia.org/wikipedia/commons/thumb/8/82/Progress_100.svg/80px-Progress_100.svg.png "100%"
[abandonned]: http://wiki.flightgear.org/images/thumb/3/30/Cross_32px.png/16px-Cross_32px.png         "abandonné"
[done]:       http://wiki.flightgear.org/images/thumb/7/75/Tick_32px.png/16px-Tick_32px.png           "fait"
[ongoing]:    http://wiki.flightgear.org/images/thumb/3/37/Ongoing.png/16px-Ongoing.png               "en cours"
[pending]:    http://wiki.flightgear.org/images/thumb/8/8d/Hourglass_32px.png/16px-Hourglass_32px.png "en attente"
[fixed]:      http://wiki.flightgear.org/images/thumb/8/85/WIP.png/26px-WIP.png                       "réparé"
[paused]:     http://wiki.flightgear.org/images/thumb/d/dc/Paused.png/16px-Paused.png                 "en pause"

# Origine du projet
Cet instrument était prévu pour s'approcher du Garmin Primus 1000. Au début il était écrit avec une multitude de petits objets 3D placés sur l'écran avec un
écart suffisament faible pour que le pilote ait l'impression d'un vrai écran 2D.  

J'avais écrit le ZKV500 qui se rapprochait d'un GPS Garmin 500, donc ZKV1000 semblait tout indiqué :-), ZKV pour Zakharov...  

Le ZKV1000 ancien (version XML) incluait aussi un moyen de rafraîchir les écrans sans altérer la vitesse d'affichage avec un système de rotation de fonctions qui chacune l'une après l'autre
s'occupait d'un seul ou d'un petit groupe d'élément à des fréquences diverses. Que l'instrument ne freine pas le simulateur était primordial.  

Le zkv1000 ancien incluait aussi une carte qui nécessitait d'être créée au préalable via ImageMagick et un autre outil de FG dont j'ai perdu le nom. Le script en Perl créeait
une carte en collant les bordures des cartes adjacentes à celle dans laquelle l'appareil se trouvait, avec ImageMagick.  Ça marchait mais le rendu était pas terrible, très peu flexible (pas de zoom, pas de génération à la volée).  

J'ai abandonné le zkv1000 par les aléeas de la vie, il a été amélioré un peu par d'autres dont j'ai oublié le nom notamment l'apport du radar de relief, mais la façon de faire n'optimisait pas du tout
la vitesse d'affichage, et à moins d'avoir une bête de course le radar était inutilisable.

Le zkv1000 incluait aussi un ensemble de menus intégrés, avec navigation par les boutons, et une recherche des balises et aéroports, ainsi qu'un calculateur de trajectoire 
simple (balise à balise).  

Regardant de temps à autre ce que devenait FG je découvrais Canvas, le SVG, et les premières réalisations de PFD/MFD avec ce nouveau jouet.  

Trop tentant, il fallait essayer de rendre le zkv1000 Canvas-compliant. Et l'aventure (re)commence!

# Objectifs
Il ne sert à rien d'essayer de reproduire à l'identique le Garmin Primus 1000, d'autres y arriveront bien mieux que moi pour créer une copie fidèle.  
Mais il est possible de s'en approcher assez fidèlement en suivant les manuels Garmin disponibles. Le zkv1000 n'a nullement la prétention de pouvoir servir de support d'entrainement officiel ou pas.  
Vous êtes prévenus!  

Dans ce projet je privilégie particulièrement  

1.  la modularité pour des évolutions futures
1.  l'optimisation, enfin... supposée, mes qualités de dev' ne sont probablement assez élevées ;)
1.  une intégration la plus simple possible dans n'importe quel appareil
1.  une utilisation qui se veut proche de ce que fait l'instrument de référence, mais en y intégrant les avantages d'être dans un simulateur et pas dans la vie réelle:
    *   ajout de fonctionnalités spécifiques
    *   retraits de fonctionnalités peu utiles dans un simulateur

# État acuel
J'ai récupéré l'implémentation du [projet "Farmin/G1000"](http://wiki.flightgear.org/Project_Farmin/FG1000). Le GDU-104X reprend l'implémentation du Garmin Primus 1000, et notamment les objets 3D, et les SVG. Les objets 3D sont bien plus jolis que ceux du premier zkv1000 (le .ac de l'ancien était tout cassé, pas réussi à réparer), et le SVG comportait déjà beaucoup d'éléments.

## général
![][50%]  
Instruments de base disponibles

* double-écran ![][40%]: PFD avec instrus de base, et MFD avec radios, pas de menus
* ![][ongoing]animations écrans ![][60%]: wrapper pour l'affichage des objets (et plus)
    * AI: ![][90%] reste l'échelle du pitch dont je ne sais pas si il faut la centrer sur le symbole de l'avion
    * VSI, IAS, IA, Compasi, HDG: ![][100%]
* animation modèle 3D ![][90%]: les boutons et molettes fonctionnent (radio, comm, softkey, etc.), il manque les textures pour les boutons du MFD

## dans le détail
* apprentissage:
  * Canvas ![][50%]
  * SVG
    * InkScape ![][80%] (enfin pour les besoins du zkv1000)
    * format ![][60%]
  * archi de l'image importée ![][100%] (avec modification directe dans Vim)
* XML ![][80%]
* ![][ongoing]structure Nasal ![][60%]:
  * en apprendre plus sur les classes (les parents multiples)
  * utilisations des nouvelles API en remplacement des anciennes (maketimer, ...)
  * enfin retrouvée la  possibilité de gérer le zkv1000 par la console Nasal et même le nouvel REPL ![][100%]

## feuille de route
1. avoir un PFD utilisable avec les fonctions de base, sans radio-navigation ![][100%]
1. afficher l'EIS ![][0%]
1. afficher les widgets du PFD ![][10%]
1. rendre disponible le MFD ![][0%]

# documentation
* [Canvas dans FG](http://wiki.flightgear.org/Category:Canvas)
* [Nasal](http://wiki.flightgear.org/Category:Nasal)
* guides récupérés depuis [le site de Garmin](http://support.garmin.com/support/manuals/searchManuals.faces)
    * [G1000 Pilot’s Guide for the Diamond DA42 (v0370.22)](http://static.garmin.com/pumac/190-00406-07_0B_Web.pdf) *(94 pages)*
    * [Pilot's Guide, Cirrus Perspective, SR2x (v0764.30)](http://static.garmin.com/pumac/190-00820-11_A.pdf) *(752 pages)*
